Subject: Perl "drill" program... (was: UNIX Logflash?)

From: "Deven T. Corzine" <[email-masked]>
Date: Wed, 23 Jan 2002 16:06:03 -0500 (EST)

Okay, I realize I'm responding to a year-old message here. That shows how 
much time I find to keep up with this mailing list, much less study Lojban!

Nevertheless, I'll respond -- if I fail to notice responses and reply to 
them, please ping me with a private email, which will get my attention.

Anyway, I'm not familiar with "LogFlash" or GNU "flashcard", but I've got a 
program I wrote in Perl a number of years ago, which I called "drill", that 
I used to learn Spanish vocabulary words. (I wrote it in late 1995 or so.)
The program used data files containing equivalent words or phrases, and it 
used either bidirectional [<->] or directional [->] mappings in the data; 
bidirectional mappings would be asked both ways.

Anyway, I used the program successfully with Spanish -- the program was 
very exacting and expected several additional right answers for every wrong 
answer. The words I was having the most trouble with, I would get wrong 
5-10 times until I finally started remembering them. Once I did, it made 
me answer them so many times that it really drilled it into my head what 
the correct answer was -- which eas exactly the point of the program. It 
was adaptive, and it could remember which words needed more work (had any 
wrong answers) for later sessions.

It wasn't a perfect program, and I never released it, but it worked very 
effectively for me...

I don't know if this is a dead issue or not, but it probably wouldn't be 
too hard to adapt the program to work with Lojban; would anyone here be 
interested in seeing this happen? (Being in Perl, it could potentially run 
fairly easily on Windows, though it was developed under Linux.)

Let me know if there's any interest... (It might also be feasible to adapt 
it into a web-based drill program, but that's probably a more involved and 
complex endeavour -- but easier for newbies to use, so maybe worthwhile?)

Deven

On Mon, 29 Jan 2001, Robert J. Chassell wrote:

> On Mon, 29 Jan 2001, Robin Lee Powell wrote:
> 
> > I know this has been discussed over and over, but does a way to access
> > logflash from my unix box _without_ emulating DOS exist? 
> 
> Besides LogFlash, there is a program that runs in GNU Emacs that does
> somewhat the same job: flashcard.
> 
> You can get it and Lojban vocabulary files from:
> 
> http://www.rattlesnake.com/lojban/
> 
> All the files you need, including the vocabulary files, are in 
> 
> lojban-flashcard.tar.gz
> 543,609 bytes
> 
> (You need to run GNU Emacs, but that runs on GNU/Linux, BSD, Microsoft,
> and other operating systems.)
> 
> Here is a copy of a note I posted awhile back.
> As I say in the note:
> 
> Unfortunately, I myself have been too busy with other activities
> to devote time to Lojban and have fallen behind.
> 
> and I am falling even further behind. <sigh> :-(
> 
> Best wishes.
> 
> 2000 May 4
> 
> Daniel Gudlat asked:
> 
> > Btw, Is there an easy way to "localize" the logflash programs?
> 
> I do not know about logflash, but you could localize the GNU Emacs
> lojban Flashcard mode -- add German or Japanese.
> 
> You can download the mode and the specially formatted gismu lists (and
> the program to recreate them) from:
> 
> http://www.rattlesnake.com/lojban/
> 
> lojban-flashcard.tar.gz
> 531k
> 
> For more of a description see:
> 
> http://www.rattlesnake.com/lojban/lojban-readme.html
> 
> 
> You would add a German definition to the English and Lojban that
> I provide. Flashcard is not limited to just two languages.
> 
> Here is what the author says:
> 
> The purpose of `flashcard' is to drill the user over a
> user-created database of questions and answers. It records
> scores, and can tailor the drill according to the user's past
> performance. To quickly summarize its features, I'll describe an
> example.
> 
> I create a vocabulary file; the top line indicates that there are
> two fields in this file, called `dutch' and `english'. (But I
> could have three or more fields if desired.) I then enter a bunch
> of pairs of Dutch and English words, one pair on a line. E.g.:
> 
> !% Fields: dutch english
> 
> wie who
> huis house
> straat street
> 
> etc.
> 
> However, rather than provide key words, for Lojban I provide both `key
> words' and complete definitions like this:
> 
> klama (kla)
> 
> come, go
> x1 come-s/goes to destination x2 from origin x3 via route x4 using
> means/vehicle x5
> 
> [also travels, journeys, moves, leaves to ... from ...; x1 is a
> traveller; (x4 as a set includes points at least sufficient to
> constrain the route relevantly)]
> 
> I don't like using single English words for Lojban, since they
> translate so poorly.
> 
> The program's author goes on to say:
> 
> Then I can use `flashcard' to drill me on this file, either
> presenting me with the `dutch' field and letting me think of the
> `english' field, or vice versa. `flashcard' will not check my
> answers (unless I'm in multiple-choice mode); I must judge if I
> got the answer right or wrong, and hit `r' or `w' accordingly.
> `flashcard' keeps score for each field and each record: how many
> times I've gotten it right, how many times I've gotten it wrong,
> and when was the last time I got it right. This information is
> stored in a separate score file.
> 
> At some later date I can come back to the same vocabulary
> file, and have `flashcard' drill me on selected cards, based
> on criteria such as "all cards which I haven't gotten right
> in a month" or "all cards which I've gotten right less than
> 75% of the time."
> 
> Multiple vocabulary files can be loaded, mixed together, and
> drilled on simultaneously. When the drilling is done, scores will
> be saved to the appropriate separate score files.
> 
> 
> You need to run GNU Emacs to run Flashcard. Fortunately GNU Emacs
> runs on a great many systems, including Microsoft Windows 95 and 98,
> various versions of Unix, and GNU/Linux.
> 
> When you start Flashcard, the program will ask you for the name of a
> file; I suggest you start with `basic-words', which I have included in
> the tar file. I just did this and this is the first screen I see
> looks like this:
> 
> 
> 
> Card #1 of 308 Overall: 0 r 0 w (0%) This card: 0 r 0 w (0%)
> 
> Question (english): brown,
> x1 is brown/tan [color adjective]
> /:/
> 
> Answer (lojban):
> 
> Press SPC if you know the answer,
> g to give up, or
> k to skip this question.
> 
> 
> When I press the space bar or the `g' key, _bunre (bur bu'e)_ appears
> 
> Here is an other example, after I press SPC:
> 
> 
> 
> Card #2 of 308 Overall: 0 r 1 w (0%) This card: 0 r 0 w (0%)
> 
> Question (english): at_least
> 
> Answer (lojban): su'o
> 
> Press g again to proceed, or
> k to skip this question.
> 
> 
> 
> 
> Unfortunately, I myself have been too busy with other activities to
> devote time to Lojban and have fallen behind.
> 
> Best wishes -- the program is free software, free as in `freedom'
> German frei (*not* kostenlos or gratis); you may do what you wish with
> it except forbid others from doing what you may do.
> 
> --
> Robert J. Chassell [email-masked]
> Rattlesnake Enterprises http://www.rattlesnake.com
> 
> 
> To unsubscribe, send mail to [email-masked]
> 
>